# Coveo ResultsFiltersPreferences Component (CoveoResultsFiltersPreferences)

The `ResultFiltersPreferences` component allows end users to create custom filters to apply to queries. These filters are saved to local storage.

Only advanced end users who understand the Coveo query syntax should use this feature (see Coveo Query Syntax Reference).

This component is normally accessible through the `Settings` menu. Its usual location in the DOM is inside the `PreferencesPanel` element.

See also the ResultsPreferences component.

## Index

### Methods

- debugInfo
- disable
- enable
- getBindings
- get

### Properties

- bind
- componentOptionsModel
- componentStateModel
- disabled
- logger
- queryController
- queryStateModel
- root
- searchInterface
- ID

### Accessors

- usageAnalytics

### Component Options

- filters
- includeInBreadcrumb
- showAdvancedFilters

### Constructors

- constructor

## Methods

### debugInfo

- debugInfo(): any

- Inherited from BaseComponent.debugInfo

  - Defined in ui/Base/BaseComponent.ts :41

  Return the debug info about this component.

  #### Returns any

### disable

- disable(): void

- Inherited from BaseComponent.disable

  - Defined in ui/Base/BaseComponent.ts :52

  Disable the component. Normally this means that the component will not execute handlers for the framework events (query events, for example). Components are enabled by default on creation.

  #### Returns void

### enable

- enable(): void

- Inherited from BaseComponent.enable

  - Defined in ui/Base/BaseComponent.ts :61

  Enable the component. Normally this means that the component will execute handlers for the framework events (query events, for example). Components are enabled by default on creation.

  #### Returns void

### getBindings

- getBindings(): IComponentBindings

- Inherited from Component.getBindings

  - Defined in ui/Base/Component.ts :328

  Return the bindings, or environment, for the current component.

  #### Returns IComponentBindings

### Static get

- get(element: HTMLElement, componentClass?: any, noThrow?: boolean): BaseComponent

- Inherited from Component.get

  - Defined in ui/Base/Component.ts :410

  Get the bound component to the given HTMLElement. Throws an assert if the HTMLElement has no component bound, unless using the noThrow argument.
  If there is multiple component bound to the current HTMLElement, you must specify the component class.

  #### Parameters

  - ##### element: HTMLElement

    HTMLElement for which to get the bound component.

  - ##### Optional componentClass: any

    Optional component class. If the HTMLElement has multiple components bound, you must specify which one you are targeting.

  - ##### Optional noThrow: boolean

    Boolean option to tell the method to not throw on error.

  #### Returns BaseComponent

## Properties

### bind

bind: ComponentEvents

Inherited from Component.bind

- Defined in ui/Base/Component.ts :270

Allows the component to bind events and execute them only when it is enabled.

type

  {Coveo.ComponentEvents}

### componentOptionsModel

componentOptionsModel: ComponentOptionsModel

Inherited from Component.componentOptionsModel

- Defined in ui/Base/Component.ts :294

Contains the state of options for different components. Mainly used by ResultLink.

### componentStateModel

componentStateModel: ComponentStateModel

Inherited from Component.componentStateModel

- Defined in ui/Base/Component.ts :282

Contains the state of different components (enabled vs disabled). Allows to get/set values. Triggers component state event when modified. Each component can listen to those events.

### disabled

disabled: boolean

Inherited from BaseComponent.disabled

- Defined in ui/Base/BaseComponent.ts :23

A disabled component will not participate in the query, or listen to ComponentEvents.

type

  {boolean}

### logger

logger: Logger

Inherited from BaseComponent.logger

- Defined in ui/Base/BaseComponent.ts :18

Allows component to log in the dev console.

### queryController

queryController: QueryController

Inherited from Component.queryController

- Defined in ui/Base/Component.ts :286

Contains the singleton that allows to trigger queries.

### queryStateModel

queryStateModel: QueryStateModel

Inherited from Component.queryStateModel

- Defined in ui/Base/Component.ts :278

Contains the state of the query. Allows to get/set values. Trigger query state event when modified. Each component can listen to those events.

### root

root: HTMLElement

Inherited from Component.root

- Defined in ui/Base/Component.ts :274

A reference to the root HTMLElement (the SearchInterface).

### searchInterface

searchInterface: SearchInterface

Inherited from Component.searchInterface

- Defined in ui/Base/Component.ts :290

A reference to the root of every component, the SearchInterface.

### Static ID

ID: string

Inherited from BaseComponent.ID

- Defined in ui/Base/BaseComponent.ts :28

The static ID that each component needs in order to be identified.
For example, SearchButton -> static ID: SearchButton -> className: CoveoSearchButton

## Accessors

### usageAnalytics

- get (): IAnalyticsClient

- Inherited from Component.usageAnalytics

  - Defined in ui/Base/Component.ts :343

  A reference to the Analytics.client.

  #### Returns IAnalyticsClient

## Component Options

### filters

filters: any

- Defined in ui/ResultsFiltersPreferences/ResultsFiltersPreferences.ts :137

Specifies the default filters which all end users can apply.

End users cannot modify or delete these filters. These filters do not count as "user-made" filters, but rather as "built-in" filters created by the developer of the search page.

Note:

> You cannot set this option directly in the component markup as an HTML attribute. You must either set it in the `init` call of your search interface (see Passing Component Options in the init Call), or before the `init` call, using the `options` top-level function (see Passing Component Options Before the init Call).

Filters should follow this definition:

`filters : { [caption : string] : { expression : string, tab? : string[] } }`;

Example:

var myFilters = { "Only Google Drive Items" : { expression : "@connectortype == 'GoogleDriveCrawler'", tab : ["Tab1", "Tab2"] },

"Another Filter" : { expression : [ ... another expression ... ] },

[ ... ] };

    // You can set the option in the 'init' call:
    Coveo.init(document.querySelector("#search"), {
      ResultsFiltersPreferences : {
        filters : myFilters
      }
    });

    // Or before the 'init' call, using the 'options' top-level function:
    // Coveo.options(document.querySelector("#search"), {
    //   ResultsFiltersPreferences : {
           filters : myFilters
         }
    // });

Default value is `undefined`.

### includeInBreadcrumb

includeInBreadcrumb: boolean

- Defined in ui/ResultsFiltersPreferences/ResultsFiltersPreferences.ts :75

Specifies whether to display the active filter(s) in the `Breadcrumb`.

Default value is `true`.

Default

  `true`

Markup configuration example(s) :

    data-include-in-breadcrumb='true'
    data-include-in-breadcrumb='false'

### showAdvancedFilters

showAdvancedFilters: boolean

- Defined in ui/ResultsFiltersPreferences/ResultsFiltersPreferences.ts :85

Specifies whether to show the Create button that allows the end user to create filters.

If you set this option to `false`, only the pre-populated `filters` are available to the end user.

Default value is `true`.

Default

  `true`

Markup configuration example(s) :

    data-show-advanced-filters='true'
    data-show-advanced-filters='false'

## Constructors

### constructor

- new ResultsFiltersPreferences(element: HTMLElement, options: IResultsFiltersPreferencesOptions, bindings: IComponentBindings): ResultsFiltersPreferences

- Overwrites Component.constructor

  - Defined in ui/ResultsFiltersPreferences/ResultsFiltersPreferences.ts :152

  Creates a new `ResultsFiltersPreferences` component.

  #### Parameters

  - ##### element: HTMLElement

    The HTMLElement on which to instantiate the component.

  - ##### options: IResultsFiltersPreferencesOptions

    The options for the `ResultsFiltersPreferences` component.

  - ##### bindings: IComponentBindings

    The bindings that the component requires to function normally. If not set, these will be automatically resolved (with a slower execution time).

  #### Returns ResultsFiltersPreferences